# -*- coding: utf-8 -*-
#
# Copyright (C) 2017 Jens Wilberg
#
# This file is part of evawords.
#
# evawords is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# evawords is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with evawords.  If not, see <http://www.gnu.org/licenses/>.
"""This module starts the program."""
import argparse
import os
from wordrating import gui

try:
    raw_input
except NameError:
    # Python3
    raw_input = input


def argparser_conf():
    """Configuration of the argparsemodul."""
    parser = argparse.ArgumentParser(
        description="ratenew words with unknown scores with the method of paired comparisions")
    parser.add_argument("wordlist", nargs="?", help="path/to/wordlist.txt")
    parser.add_argument("--random-width", "-r", type=int,
                        metavar='I', help="Use random width I. I must be a int between 0 and 100 (default 0)")
    return parser


def main():
    """Mainfunction to start the program."""
    # arg = False
    #
    # uin = False
    # # Parse command line arguments
    # if len(sys.argv) == 2:
    #     if os.path.exists(sys.argv[1]):
    #         if sys.argv[1].endswith(".txt"):
    #             tmp = os.path.abspath(__file__)
    #             tmp = os.path.dirname(tmp)
    #             if os.path.exists(os.path.join(tmp, "wordrating", "data",
    #                                            "config")):
    #                 print("If you continue, your old progress will be"
    #                       "overwritten.")
    #                 print("('no' will start the standard gui)")
    #                 while True:
    #                     uin = raw_input("Continue? [yes|no]: ")
    #                     try:
    #                         uin = valid[uin.lower()]
    #                         break
    #                     except KeyError:
    #                         print("Invalid answer!\n")
    #                 if uin:
    #                     arg = sys.argv[1]
    #             else:
    #                 arg = sys.argv[1]
    #         else:
    #             print("Wrong datatype for the wordlist: %s" %
    #                   (os.path.basename(sys.argv[1])))
    #             print("Only *.txt is supported\n")
    #             print("wordrating.py wordlist.txt")
    #             print("\twordlist.txt can be left empty to start the gui.")
    #             exit(0)
    #     else:
    #         print("%s does not exist!\n" % (sys.argv[1]))
    #         print("wordrating.py wordlist.txt")
    #         print("\twordlist.txt can be left empty to start the gui.")
    #         exit(0)
    # elif len(sys.argv) > 2:
    #     print("Too many arguments!\n")
    #     print("wordrating.py wordlist.txt")
    #     print("\twordlist.txt can be left empty to start the gui.")
    #     exit(0)
    parser = argparser_conf()
    args = parser.parse_args()
    random_width = 0
    if args.random_width:
        if args.random_width <= 0:
            parser.error(
                "argument --random-width/-r: invalid int value (0-100): '%s'"
                % args.random_width)
        random_width = args.random_width
    arg = args.wordlist
    valid = {"yes": True, "no": False, "y": True, "n": False}
    prog_dir = os.path.dirname(os.path.abspath(__file__))
    if os.path.exists(os.path.join(prog_dir, "data", "config")) and arg:
        print("If you continue, your old progress will be "
              "overwritten.")
        print("('no' will start the standard gui)")
        while True:
            uin = raw_input("Continue? [yes|no]: ")
            try:
                uin = valid[uin.lower()]
                break
            except KeyError:
                print("Invalid answer!\n")
        if not uin:
            arg = None

    gui.run(arg, random_width)


if __name__ == '__main__':
    main()
